local Attributes =  FlexBar2:NewModule("Attributes");
local SecureStateDriverFrame = CreateFrame("Frame", nil, UIParent, "SecureStateDriverTemplate");


Attributes.ButtonMixin = FlexBar2.OO.Mixin
{
	"GetModifiedAttribute",
    "SetAttribute",
};

function Attributes.ButtonMixin:Activate()
    self.AttributeCache = {};
    SecureStateDriverFrame:SetAttribute("addchild", self.Frame);
	self:RegisterScript("OnAttributeChanged",
		function(self)
			local AttributeCache = self.AttributeCache;
			for n ,_ in pairs(AttributeCache) do
				AttributeCache[n] = nil;
			end
		end);
end

function Attributes.ButtonMixin:SetAttribute(Attribute, Value)
    self.Frame:SetAttribute(Attribute, Value);
end

function Attributes.ButtonMixin:GetModifiedAttribute(Attribute, Value)
	if(not self.AttributeCache[Attribute]) then
        self.AttributeCache[Attribute] = SecureButton_GetModifiedAttribute(self.Frame, Attribute, SecureStateChild_GetEffectiveButton(self.Frame)) or "";
    end
    return self.AttributeCache[Attribute];
end
